      subroutine Agrif_initworkspace()      


      use Agrif_Util
#include "Param_BeforeCall_Agrif_initworkspace.h"
      

        call Sub_Loop_Agrif_initworkspace( Agrif_tabvars_i(18)%iarray0, 
     &Agrif_tabvars_i(17)%iarray0, Agrif_tabvars_i(27)%iarray0, Agrif_ta
     &bvars_i(26)%iarray0, Agrif_tabvars_i(25)%iarray0, Agrif_tabvars_i(
     &24)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(13)%iarr
     &ay0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif
     &_tabvars_i(3)%iarray0, Agrif_tabvars_i(1)%iarray0, Agrif_tabvars_i
     &(16)%iarray0, Agrif_tabvars_i(15)%iarray0)

      end


#include "Sub_Loop_Agrif_initworkspace.h"
      subroutine Agrif_initvalues()      

      use AGRIF_UTIL
#include "Param_BeforeCall_Agrif_initvalues.h"
      

        call Sub_Loop_Agrif_initvalues( Agrif_tabvars_i(8)%iarray0, Agri
     &f_tabvars_i(7)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars
     &_i(4)%iarray0, Agrif_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iar
     &ray0, Agrif_tabvars_i(212)%iarray0, Agrif_tabvars_i(213)%iarray0, 
     &Agrif_tabvars_i(215)%iarray0, Agrif_tabvars_i(205)%iarray0, Agrif_
     &tabvars(153)%array3, Agrif_tabvars(154)%array3, Agrif_tabvars(56)%
     &array4, Agrif_tabvars(57)%array4, Agrif_tabvars(48)%array3, Agrif_
     &tabvars(50)%array3, Agrif_tabvars(51)%array3, Agrif_tabvars_i(229)
     &%iarray0, Agrif_tabvars_i(230)%iarray0, Agrif_tabvars_i(156)%iarra
     &y0, Agrif_tabvars_i(231)%iarray0, Agrif_tabvars_i(158)%iarray0, Ag
     &rif_tabvars_i(147)%iarray0, Agrif_tabvars_i(152)%iarray0, Agrif_ta
     &bvars_i(227)%iarray0, Agrif_tabvars_i(228)%iarray0, Agrif_tabvars(
     &69)%array5, Agrif_tabvars(67)%array4, Agrif_tabvars(68)%array4, Ag
     &rif_tabvars_l(11)%larray0, Agrif_tabvars(72)%array5, Agrif_tabvars
     &(70)%array4, Agrif_tabvars(71)%array4, Agrif_tabvars_l(12)%larray0
     &, Agrif_tabvars(63)%array5, Agrif_tabvars(61)%array4, Agrif_tabvar
     &s(62)%array4, Agrif_tabvars_l(13)%larray0, Agrif_tabvars(148)%arra
     &y5, Agrif_tabvars(66)%array5, Agrif_tabvars(149)%array4, Agrif_tab
     &vars(64)%array4, Agrif_tabvars(150)%array4, Agrif_tabvars(65)%arra
     &y4, Agrif_tabvars_l(14)%larray0, Agrif_tabvars_i(233)%iarray0, Agr
     &if_tabvars_i(234)%iarray0, Agrif_tabvars_i(235)%iarray0, Agrif_tab
     &vars_i(241)%iarray0, Agrif_tabvars_i(237)%iarray0, Agrif_tabvars_i
     &(239)%iarray0, Agrif_tabvars_r(7)%array0, Agrif_tabvars_i(148)%iar
     &ray0, Agrif_tabvars_i(151)%iarray0, Agrif_tabvars_l(1)%larray1, Ag
     &rif_tabvars_l(4)%larray0, Agrif_tabvars_r(8)%array0, Agrif_tabvars
     &_r(9)%array0, Agrif_tabvars_r(5)%array0, Agrif_tabvars_i(162)%iarr
     &ay0, Agrif_tabvars_i(167)%iarray0, Agrif_tabvars_i(157)%iarray0, A
     &grif_tabvars_i(18)%iarray0, Agrif_tabvars_i(17)%iarray0, Agrif_tab
     &vars_i(27)%iarray0, Agrif_tabvars_i(26)%iarray0, Agrif_tabvars_i(2
     &5)%iarray0, Agrif_tabvars_i(24)%iarray0, Agrif_tabvars_i(3)%iarray
     &0, Agrif_tabvars_i(1)%iarray0, Agrif_tabvars_i(16)%iarray0, Agrif_
     &tabvars_i(15)%iarray0)

      end


#include "Sub_Loop_Agrif_initvalues.h"
      subroutine declare_zoom_variables()      

      use AGRIF_UTIL
#include "Param_BeforeCall_declare_zoom_variables.h"
      

        call Sub_Loop_declare_zoom_variables( Agrif_tabvars_i(206)%iarra
     &y0, Agrif_tabvars_i(210)%iarray0, Agrif_tabvars_i(207)%iarray0, Ag
     &rif_tabvars_i(211)%iarray0, Agrif_tabvars_i(208)%iarray0, Agrif_ta
     &bvars_i(209)%iarray0, Agrif_tabvars_i(212)%iarray0, Agrif_tabvars_
     &i(213)%iarray0, Agrif_tabvars_i(214)%iarray0, Agrif_tabvars_i(205)
     &%iarray0, Agrif_tabvars_i(215)%iarray0, Agrif_tabvars_i(194)%iarra
     &y0, Agrif_tabvars_i(192)%iarray0, Agrif_tabvars_i(196)%iarray0, Ag
     &rif_tabvars_i(195)%iarray0, Agrif_tabvars_i(193)%iarray0, Agrif_ta
     &bvars_i(197)%iarray0, Agrif_tabvars_i(198)%iarray0, Agrif_tabvars_
     &i(199)%iarray0, Agrif_tabvars_i(201)%iarray0, Agrif_tabvars_i(200)
     &%iarray0, Agrif_tabvars_i(202)%iarray0, Agrif_tabvars_i(203)%iarra
     &y0, Agrif_tabvars_i(217)%iarray0, Agrif_tabvars_i(218)%iarray0, Ag
     &rif_tabvars_i(219)%iarray0, Agrif_tabvars_i(220)%iarray0, Agrif_ta
     &bvars_l(13)%larray0, Agrif_tabvars_l(14)%larray0, Agrif_tabvars_l(
     &11)%larray0, Agrif_tabvars_l(12)%larray0, Agrif_tabvars_i(221)%iar
     &ray0, Agrif_tabvars_i(223)%iarray0, Agrif_tabvars_i(222)%iarray0, 
     &Agrif_tabvars_i(224)%iarray0, Agrif_tabvars_i(8)%iarray0, Agrif_ta
     &bvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars_i(7
     &)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0
     &)

      end


#include "Sub_Loop_declare_zoom_variables.h"

       recursive subroutine ResetMask()      

      use Agrif_Util
#include "Param_BeforeCall_ResetMask.h"
      

        call Sub_Loop_ResetMask( Agrif_tabvars_i(14)%iarray0, Agrif_tabv
     &ars_i(4)%iarray0, Agrif_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%
     &iarray0, Agrif_tabvars_i(205)%iarray0, Agrif_tabvars_r(22)%array0,
     & Agrif_tabvars(77)%array2, Agrif_tabvars(80)%array2, Agrif_tabvars
     &(78)%array2, Agrif_tabvars(79)%array2, Agrif_tabvars(81)%array2, A
     &grif_tabvars_i(8)%iarray0, Agrif_tabvars_i(7)%iarray0)

      end


#include "Sub_Loop_ResetMask.h"

      Subroutine Updateh(tabres,i1,i2,j1,j2,before)      


      use Agrif_Util
#include "Param_BeforeCall_Updateh.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      real, dimension(i1:i2,j1:j2) :: tabres
      logical :: before
      

        call Sub_Loop_Updateh(tabres,i1,i2,j1,j2,before, Agrif_tabvars_i
     &(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%iarr
     &ay0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars(143)%array3, Agrif_
     &tabvars(147)%array3, Agrif_tabvars(142)%array3, Agrif_tabvars(155)
     &%array2, Agrif_tabvars(4)%array1, Agrif_tabvars(2)%array1, Agrif_t
     &abvars(3)%array1, Agrif_tabvars(1)%array1, Agrif_tabvars(146)%arra
     &y3, Agrif_tabvars_r(26)%array0, Agrif_tabvars(114)%array2, Agrif_t
     &abvars_r(35)%array0, Agrif_tabvars(81)%array2, Agrif_tabvars(115)%
     &array2, Agrif_tabvars_i(8)%iarray0, Agrif_tabvars_i(7)%iarray0)

      end


#include "Sub_Loop_Updateh.h"
      Subroutine Updatermask(tabres,i1,i2,j1,j2,before)      


      use Agrif_Util
#include "Param_BeforeCall_Updatermask.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      real, dimension(i1:i2,j1:j2) :: tabres
      logical :: before
      

        call Sub_Loop_Updatermask(tabres,i1,i2,j1,j2,before, Agrif_tabva
     &rs_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%
     &iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars(81)%array2, Agr
     &if_tabvars_i(8)%iarray0, Agrif_tabvars_i(7)%iarray0)

      end


#include "Sub_Loop_Updatermask.h"
      recursive Subroutine UpdateGridhis()      


      use Agrif_Util
#include "Param_BeforeCall_UpdateGridhis.h"
      

        call Sub_Loop_UpdateGridhis( Agrif_tabvars_i(14)%iarray0, Agrif_
     &tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%iarray0, Agrif_tabvars_i
     &(2)%iarray0)

      end


#include "Sub_Loop_UpdateGridhis.h"

      subroutine hinterp(tabres,i1,i2,j1,j2,before,nb,ndir)      


      use Agrif_Util
#include "Param_BeforeCall_hinterp.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      logical :: before
      real, dimension(i1:i2,j1:j2) :: tabres
      integer(4) :: nb
      integer(4) :: ndir
      

        call Sub_Loop_hinterp(tabres,i1,i2,j1,j2,before,nb,ndir, Agrif_t
     &abvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(
     &13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars_i(8)%iarray
     &0, Agrif_tabvars_i(7)%iarray0, Agrif_tabvars_r(26)%array0, Agrif_t
     &abvars(114)%array2, Agrif_tabvars(115)%array2)

      end


#include "Sub_Loop_hinterp.h"
      subroutine hinterp_old(tabres,i1,i2,j1,j2)      


      use Agrif_Util
#include "Param_BeforeCall_hinterp_old.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      real, dimension(i1:i2,j1:j2) :: tabres
      

        call Sub_Loop_hinterp_old(tabres,i1,i2,j1,j2, Agrif_tabvars_i(14
     &)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%iarray0
     &, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars(115)%array2)

      end


#include "Sub_Loop_hinterp_old.h"
        Subroutine Agrif_Invloc(indloc,proc,dir,indglob)      


      use Agrif_Util
#include "Param_BeforeCall_Agrif_Invloc.h"
      integer(4) :: indloc
      integer(4) :: proc
      integer(4) :: dir
      integer(4) :: indglob
      

        call Sub_Loop_Agrif_Invloc(indloc,proc,dir,indglob, Agrif_tabvar
     &s_i(11)%iarray0, Agrif_tabvars_i(9)%iarray0)

      end


#include "Sub_Loop_Agrif_Invloc.h"
        subroutine Agrif_get_proc_info ( oimin, oimax, ojmin, ojmax )      


      use Agrif_Util
#include "Param_BeforeCall_Agrif_get_proc_info.h"
      integer(4), intent(out) :: oimin
      integer(4), intent(out) :: oimax
      integer(4), intent(out) :: ojmin
      integer(4), intent(out) :: ojmax
      

        call Sub_Loop_Agrif_get_proc_info(oimin,oimax,ojmin,ojmax, Agrif
     &_tabvars_i(12)%iarray0, Agrif_tabvars_i(11)%iarray0, Agrif_tabvars
     &_i(10)%iarray0, Agrif_tabvars_i(9)%iarray0)

      end


#include "Sub_Loop_Agrif_get_proc_info.h"

        subroutine Agrif_estimate_parallel_cost(i1,i2,j1,j2,nbprocs,
     &                                          grid_cost)
      use Agrif_Types, only : Agrif_tabvars

      implicit none

#include "Param_BeforeCall_Agrif_estimate_parallel_cost.h"
      integer(4), intent(in) :: i1
      integer(4), intent(in) :: i2
      integer(4), intent(in) :: j1
      integer(4), intent(in) :: j2
      integer(4), intent(in) :: nbprocs
      real, intent(out) :: grid_cost

                     

                                                          
                                          
        grid_cost = (i2-i1+1)*(j2-j1+1) / real(nbprocs)
        end subroutine agrif_estimate_parallel_cost
      SUBROUTINE Agrif_detect(taberr,sizexy)      

      use AGRIF_types

      use Agrif_Util
#include "Param_BeforeCall_Agrif_detect.h"
      Integer(4), dimension(1:2) :: sizexy
      Integer(4), dimension(1:sizexy(1),1:sizexy(2)) :: taberr
      

        call Sub_Loop_Agrif_detect(taberr,sizexy, Agrif_tabvars_i(14)%ia
     &rray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%iarray0, Ag
     &rif_tabvars_i(2)%iarray0, Agrif_tabvars(150)%array4, Agrif_tabvars
     &_i(155)%iarray0, Agrif_tabvars(149)%array4, Agrif_tabvars_i(8)%iar
     &ray0, Agrif_tabvars_i(7)%iarray0, Agrif_tabvars_i(16)%iarray0, Agr
     &if_tabvars_i(15)%iarray0)

      end


#include "Sub_Loop_Agrif_detect.h"

      Subroutine Agrif_Before_Regridding()      


      use Agrif_Util
#include "Param_BeforeCall_Agrif_Before_Regridding.h"
      

        call Sub_Loop_Agrif_Before_Regridding( Agrif_tabvars_i(14)%iarra
     &y0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%iarray0, Agrif
     &_tabvars_i(2)%iarray0, Agrif_tabvars_i(209)%iarray0, Agrif_tabvars
     &(148)%array5, Agrif_tabvars_i(210)%iarray0, Agrif_tabvars(149)%arr
     &ay4, Agrif_tabvars_i(211)%iarray0, Agrif_tabvars(150)%array4, Agri
     &f_tabvars_i(212)%iarray0, Agrif_tabvars(153)%array3, Agrif_tabvars
     &_i(213)%iarray0, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars(154)%
     &array3, Agrif_tabvars_i(214)%iarray0, Agrif_tabvars(155)%array2, A
     &grif_tabvars_i(8)%iarray0, Agrif_tabvars_i(7)%iarray0, Agrif_tabva
     &rs_i(16)%iarray0, Agrif_tabvars_i(15)%iarray0)

      end


#include "Sub_Loop_Agrif_Before_Regridding.h"

      subroutine inith(tabres,i1,i2,j1,j2,before)      


      use Agrif_Util
#include "Param_BeforeCall_inith.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      real, dimension(i1:i2,j1:j2) :: tabres
      logical :: before
      

        call Sub_Loop_inith(tabres,i1,i2,j1,j2,before, Agrif_tabvars_i(1
     &4)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%iarray
     &0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars(115)%array2, Agrif_ta
     &bvars_i(8)%iarray0, Agrif_tabvars_i(7)%iarray0)

      end


#include "Sub_Loop_inith.h"
      subroutine initzeta(tabres,i1,i2,j1,j2,before)      


      use Agrif_Util
#include "Param_BeforeCall_initzeta.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      real, dimension(i1:i2,j1:j2) :: tabres
      logical :: before
      

        call Sub_Loop_initzeta(tabres,i1,i2,j1,j2,before, Agrif_tabvars_
     &i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%iar
     &ray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars(75)%array3, Agrif_
     &tabvars(155)%array2, Agrif_tabvars_i(8)%iarray0, Agrif_tabvars_i(7
     &)%iarray0)

      end


#include "Sub_Loop_initzeta.h"
      subroutine initubar(tabres,i1,i2,j1,j2,before)      


      use Agrif_Util
#include "Param_BeforeCall_initubar.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      real, dimension(i1:i2,j1:j2) :: tabres
      logical :: before
      

        call Sub_Loop_initubar(tabres,i1,i2,j1,j2,before, Agrif_tabvars_
     &i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%iar
     &ray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars_i(155)%iarray0, Ag
     &rif_tabvars(154)%array3, Agrif_tabvars_i(8)%iarray0, Agrif_tabvars
     &_i(7)%iarray0)

      end


#include "Sub_Loop_initubar.h"
      subroutine initvbar(tabres,i1,i2,j1,j2,before)      


      use Agrif_Util
#include "Param_BeforeCall_initvbar.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      real, dimension(i1:i2,j1:j2) :: tabres
      logical :: before
      

        call Sub_Loop_initvbar(tabres,i1,i2,j1,j2,before, Agrif_tabvars_
     &i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%iar
     &ray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars_i(155)%iarray0, Ag
     &rif_tabvars(153)%array3, Agrif_tabvars_i(8)%iarray0, Agrif_tabvars
     &_i(7)%iarray0)

      end


#include "Sub_Loop_initvbar.h"
      subroutine initu(tabres,i1,i2,j1,j2,k1,k2,before)      


      use Agrif_Util
#include "Param_BeforeCall_initu.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      real, dimension(i1:i2,j1:j2,k1:k2) :: tabres
      logical :: before
      

        call Sub_Loop_initu(tabres,i1,i2,j1,j2,k1,k2,before, Agrif_tabva
     &rs_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%
     &iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars_i(155)%iarray0,
     & Agrif_tabvars(150)%array4, Agrif_tabvars_i(8)%iarray0, Agrif_tabv
     &ars_i(7)%iarray0)

      end


#include "Sub_Loop_initu.h"
      subroutine initv(tabres,i1,i2,j1,j2,k1,k2,before)      


      use Agrif_Util
#include "Param_BeforeCall_initv.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      real, dimension(i1:i2,j1:j2,k1:k2) :: tabres
      logical :: before
      

        call Sub_Loop_initv(tabres,i1,i2,j1,j2,k1,k2,before, Agrif_tabva
     &rs_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%
     &iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars_i(155)%iarray0,
     & Agrif_tabvars(149)%array4, Agrif_tabvars_i(8)%iarray0, Agrif_tabv
     &ars_i(7)%iarray0)

      end


#include "Sub_Loop_initv.h"
      subroutine initt(tabres,i1,i2,j1,j2,k1,k2,m1,m2,before)      


      use Agrif_Util
#include "Param_BeforeCall_initt.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      integer(4) :: m1
      integer(4) :: m2
      real, dimension(i1:i2,j1:j2,k1:k2,m1:m2) :: tabres
      logical :: before
      

        call Sub_Loop_initt(tabres,i1,i2,j1,j2,k1,k2,m1,m2,before, Agrif
     &_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_
     &i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars_l(5)%larr
     &ay1, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars(148)%array5, Agri
     &f_tabvars_i(8)%iarray0, Agrif_tabvars_i(7)%iarray0)

      end


#include "Sub_Loop_initt.h"
      subroutine computenbmaxtimes()      


      use Agrif_Util
#include "Param_BeforeCall_computenbmaxtimes.h"
      

        call Sub_Loop_computenbmaxtimes( Agrif_tabvars_i(8)%iarray0, Agr
     &if_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvar
     &s_i(7)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%ia
     &rray0)

      end


#include "Sub_Loop_computenbmaxtimes.h"
      recursive subroutine write_number(j,nbstep2d)      


      use Agrif_Util
#include "Param_BeforeCall_write_number.h"
      integer(4) :: j
      integer(4), dimension(0:20) :: nbstep2d
      

        call Sub_Loop_write_number(j,nbstep2d, Agrif_tabvars_i(161)%iarr
     &ay0, Agrif_tabvars_i(8)%iarray0, Agrif_tabvars_i(13)%iarray0, Agri
     &f_tabvars_i(2)%iarray0, Agrif_tabvars_i(7)%iarray0, Agrif_tabvars_
     &i(14)%iarray0, Agrif_tabvars_i(4)%iarray0)

      end


#include "Sub_Loop_write_number.h"

      recursive subroutine write_prestep3d(j)      


      use Agrif_Util
#include "Param_BeforeCall_write_prestep3d.h"
      integer(4) :: j
      

        call Sub_Loop_write_prestep3d(j, Agrif_tabvars_i(8)%iarray0, Agr
     &if_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvar
     &s_i(7)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%ia
     &rray0)

      end


#include "Sub_Loop_write_prestep3d.h"

      recursive subroutine write_step2d(j,nbstep2d)      


      use Agrif_Util
#include "Param_BeforeCall_write_step2d.h"
      integer(4) :: j
      integer(4), dimension(0:20) :: nbstep2d
      

        call Sub_Loop_write_step2d(j,nbstep2d, Agrif_tabvars_i(161)%iarr
     &ay0, Agrif_tabvars_i(8)%iarray0, Agrif_tabvars_i(13)%iarray0, Agri
     &f_tabvars_i(2)%iarray0, Agrif_tabvars_i(7)%iarray0, Agrif_tabvars_
     &i(14)%iarray0, Agrif_tabvars_i(4)%iarray0)

      end


#include "Sub_Loop_write_step2d.h"

      recursive subroutine write_step3d1(j)      


      use Agrif_Util
#include "Param_BeforeCall_write_step3d1.h"
      integer(4) :: j
      

        call Sub_Loop_write_step3d1(j, Agrif_tabvars_i(8)%iarray0, Agrif
     &_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars_
     &i(7)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarr
     &ay0)

      end


#include "Sub_Loop_write_step3d1.h"

      recursive subroutine write_step3d2(j)      


      use Agrif_Util
#include "Param_BeforeCall_write_step3d2.h"
      integer(4) :: j
      

        call Sub_Loop_write_step3d2(j, Agrif_tabvars_i(8)%iarray0, Agrif
     &_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars_
     &i(7)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarr
     &ay0)

      end


#include "Sub_Loop_write_step3d2.h"

      recursive subroutine agrif_read_fixed(jp,j,nunit)      


      use Agrif_Util
#include "Param_BeforeCall_agrif_read_fixed.h"
      integer(4) :: j
      integer(4) :: nunit
      integer(4) :: jp
      

        call Sub_Loop_agrif_read_fixed(jp,j,nunit, Agrif_tabvars_i(8)%ia
     &rray0, Agrif_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Ag
     &rif_tabvars_i(7)%iarray0, Agrif_tabvars_i(14)%iarray0, Agrif_tabva
     &rs_i(4)%iarray0)

      end


#include "Sub_Loop_agrif_read_fixed.h"
